#include "StdAfx.h"
#include "ChangeNoticePushController.h"
#include "ServerAddrConfig.h"
#include <afxstr.h>

ChangeNoticePushController::ChangeNoticePushController(void)
{
	m_strPrevLastModifyTime = _T("");
    m_nChangeNoticeSeq = 0;
    m_ChangeTypeCode = CHANGETYPE_CHC01;
    bExposeLogin = FALSE;
    bExposePopup = FALSE;
    bExposeCycleLogin = FALSE;
    bExposeCycleDay = FALSE;
    bExposeCycleMin = FALSE;
}

ChangeNoticePushController::~ChangeNoticePushController(void)
{
}


void ChangeNoticePushController::SetNoticeData( const ChangeNoticePushData &changeNotice )
{
	SetChangeNoticeSeq(changeNotice.nChangeNoticeSeq);
	m_strCurrentLastModifyTime = changeNotice.strLastModifyYMDT.c_str();
	SetCheckReasonKR(changeNotice.strChekReason.c_str());
	SetCheckReasonEN(changeNotice.strChekReasonEn.c_str());
	SetCheckReasonJP(changeNotice.strChekReasonJp.c_str());
	SetCheckReasonCN(changeNotice.strChekReasonCn.c_str());
	SetCheckReasonTW(changeNotice.strChekReasonTw.c_str());

	CString strChangeTypeCode(changeNotice.strChangeTypeCode.c_str());
	if (strChangeTypeCode == L"CHC01")
	{
		SetChangeTypeCode(CHANGETYPE_CHC01);
	}
	else if (strChangeTypeCode == L"CHC02")
	{
		SetChangeTypeCode(CHANGETYPE_CHC02);
	}
	else if(strChangeTypeCode == L"CHC03")
	{
		SetChangeTypeCode(CHANGETYPE_CHC03);
	}
	else
	{
	}

	if (changeNotice.vecCoList.size() > 0)
	{
		std::vector<WSTRING>::const_iterator iterInsertPos = m_vecCoList.begin();
		m_vecCoList.insert(iterInsertPos, changeNotice.vecCoList.begin(), changeNotice.vecCoList.end());
	}

	std::vector<WSTRING>::const_iterator itr = changeNotice.vecExposureCycleCd.begin();
	for(;itr != changeNotice.vecExposureCycleCd.end();++itr)
	{
		WSTRING str = *itr;
		CString strExposesureCycle(str.c_str());
		if (strExposesureCycle== L"EXC01") // α(αν) ش
			bExposeCycleLogin = TRUE;
		else if (strExposesureCycle == L"EXC02") //1 1ȸ
			bExposeCycleDay = TRUE;
		else if (strExposesureCycle == L"EXC03") //  10 1ȸ
			bExposeCycleMin = TRUE;
	}


	SetExposeTime(changeNotice.strExposureHM.c_str());

	std::vector<WSTRING>::const_iterator itrExposeLocation = changeNotice.vecExposureLocation.begin();
	for(;itrExposeLocation != changeNotice.vecExposureLocation.end();++itrExposeLocation)
	{
		WSTRING str = *itrExposeLocation;
		CString strExposeLocation(str.c_str());
		if (strExposeLocation == _T("ELC01")) // α(αν) ش
			bExposeLogin = TRUE;
		else if (strExposeLocation == L"ELC02") //˾ ش
			bExposePopup = TRUE;
	}

	SetStartTime(_ttol(changeNotice.strStartYMDT.c_str()));
	SetEndTime(_ttol(changeNotice.strEndYMDT.c_str()));
	SetCheckStartYMDT(_ttol(changeNotice.strCheckStartYMDT.c_str()));
	SetCheckEndYMDT(_ttol(changeNotice.strCheckEndYMDT.c_str()));
}

void ChangeNoticePushController::SetChangeTypeCode( ChangeType typeCode )
{
	if (typeCode == CHANGETYPE_CHC01)//
	{
		m_ChangeTypeCode = CHANGETYPE_CHC01;
		m_strChangeTypeTitle = LoadStringFromResource(IDS_STRING616);
	}
	else if(typeCode == CHANGETYPE_CHC02)//ӽ
	{
		m_ChangeTypeCode = CHANGETYPE_CHC02;
		m_strChangeTypeTitle = LoadStringFromResource(IDS_STRING617);
	}
	else if(typeCode == CHANGETYPE_CHC03)//
	{
		m_ChangeTypeCode = CHANGETYPE_CHC03;
		m_strChangeTypeTitle = LoadStringFromResource(IDS_STRING618);
	}
}

void ChangeNoticePushController::SetExposeTime( CString strHM )
{
	CTime curTime = CTimeConversion::GetKoreaTime();
	CString strExposeTime;
	strExposeTime.Format(_T("%04d-%02d-%02d %s:00"), curTime.GetYear(), curTime.GetMonth(), curTime.GetDay(), strHM);

	int nYear= _ttoi(strExposeTime.Left(4));
	int nMon = _ttoi(strExposeTime.Mid(5,2));
	int nDay = _ttoi(strExposeTime.Mid(8,2));
	int nHour= _ttoi(strExposeTime.Mid(11,2));
	int nMin = _ttoi(strExposeTime.Mid(14,2));
	int nSec = _ttoi(strExposeTime.Mid(17,2));
	CTime ExposeTime(nYear, nMon, nDay, nHour, nMin, nSec);

	m_timeExposureHM = ExposeTime;
}

void ChangeNoticePushController::SetStartTime( long ltime )
{
	CTime time(ltime);
	m_timeStartYMDT = time;
}

void ChangeNoticePushController::SetEndTime( long ltime )
{
	CTime time(ltime);
	m_timeEndYMDT = time;
}

void ChangeNoticePushController::SetCheckStartYMDT( long ltime )
{
	CTime time(ltime);
	m_timeCheckStartYMDT = time;
}

void ChangeNoticePushController::SetCheckEndYMDT( long ltime )
{
	CTime time(ltime);
	m_timeCheckEndTMDT = time;
}



BOOL ChangeNoticePushController::IsExposeLogin()
{	
	return bExposeLogin;
}

void ChangeNoticePushController::Clear()
{
	bExposeLogin = FALSE;
	bExposePopup = FALSE;
	bExposeCycleLogin = FALSE;
	bExposeCycleDay = FALSE;
	bExposeCycleMin = FALSE;
	m_strChekReason = _T("");					//
	m_strChekReasonEn = _T("");					//()
	m_strChekReasonJp = _T("");					//(Ͼ)
	m_strChekReasonCn = _T("");					//(߱ü)
	m_strChekReasonTw = _T("");					//(߱ü)
	vecExposureCycleCd.clear();	//ֱŸڵ 
	vecExposureLocation.clear();	//ġ  
	m_vecCoList.clear();
}


BOOL ChangeNoticePushController::IsLoginDlgShow()
{

	CTime curTime = CTimeConversion::GetKoreaTime();

	if (
		curTime >= m_timeStartYMDT &&
		curTime <= m_timeEndYMDT && bExposeLogin)
	{
		return TRUE;
	}
	return FALSE;
}


BOOL ChangeNoticePushController::IsExposeDomain()
{
	//TODO: differ with ChangeNoticeController::IsExposeDomain
	// is the missing change the code?
    switch (CServerAddrConfig::Instance().GetServerType())
    {
    case SERVER_TYPE_REAL:
        {
            std::vector<WSTRING>::const_iterator itr = m_vecCoList.begin();
            for(;itr != m_vecCoList.end();++itr)
            {
                WSTRING str = *itr;
                CString strExposeDomain(str.c_str());
                if (strExposeDomain == g_stNtalkInfo.strCorp) // α(αν) ش
                {
                    return TRUE;
                }
            }
            return FALSE;
        }
        break;  //lint !e527
    default:
        break;
    }
    return TRUE;

//	//   üũ Ѵ.
//#if defined(_SERVER_VERSION_REAL)
//	std::vector<WSTRING>::const_iterator itr = m_vecCoList.begin();
//	for(;itr != m_vecCoList.end();++itr)
//	{
//		WSTRING str = *itr;
//		CString strExposeDomain(str.c_str());
//		if (strExposeDomain == g_stNtalkInfo.strCorp) // α(αν) ش
//			return TRUE;
//	}
//	return FALSE;
//#else
//	//, ¡    ش.
//	return TRUE;
//#endif
}

BOOL ChangeNoticePushController::IsNewNotice()
{
	if (m_strCurrentLastModifyTime == m_strPrevLastModifyTime)
	{
		return	FALSE;
	}
	else
	{
		m_strPrevLastModifyTime = m_strCurrentLastModifyTime;
		return TRUE;
	}
}

BOOL ChangeNoticePushController::IsNoticeDlgDayShow()
{

	CTime curTime = CTimeConversion::GetKoreaTime();
	if (curTime >= m_timeStartYMDT &&
		curTime <= m_timeEndYMDT && 
		curTime.GetYear() == m_timeExposureHM.GetYear() &&
		curTime.GetMonth() == m_timeExposureHM.GetMonth() &&
		curTime.GetDay() == m_timeExposureHM.GetDay() &&
		curTime.GetHour() == m_timeExposureHM.GetHour() &&
		curTime.GetMinute() == m_timeExposureHM.GetMinute() && bExposeCycleDay
		&& IsNewNotice() 
		&& IsExposeDomain())
	{
		return TRUE;
	}
	return FALSE;
}

BOOL ChangeNoticePushController::IsNoticeDlgCheckBeforeShow()
{
	CTime curTime = CTimeConversion::GetKoreaTime();
	CTime checkBeforeTime = m_timeCheckStartYMDT - CTimeSpan(600);
	if (curTime >= m_timeStartYMDT &&
		curTime <= m_timeEndYMDT && 
		curTime.GetYear() == checkBeforeTime.GetYear() &&
		curTime.GetMonth() == checkBeforeTime.GetMonth() &&
		curTime.GetDay() == checkBeforeTime.GetDay() &&
		curTime.GetHour() == checkBeforeTime.GetHour() &&
		curTime.GetMinute() == checkBeforeTime.GetMinute()  && bExposeCycleMin
		&& IsNewNotice()
		&& IsExposeDomain())
	{
		return TRUE;
	}
	return FALSE;
}

